PAGE 64,132
TITLE		CAPS6300.ASM		03/20/88
SUBTTL		SET CAPS LOCK ON - Douglas L. Fraleigh

CODE_SEG	SEGMENT	PUBLIC
	ASSUME	CS:CODE_SEG, DS:CODE_SEG, ES:CODE_SEG, SS:CODE_SEG
	ORG	100h

MAIN		PROC	NEAR
	XOR	AX,AX			;CLEAR AX
	MOV	ES,AX			;POINT ES TO BIOS
	MOV	BX,417h			;SHIFT STATUS BYTE
	MOV	AL,ES:[BX]		;INPUT IT
	OR	AL,40h			;MASK TO SET CAPSLOCK
	MOV	ES:[BX],AL		;REPLACE STATUS BYTE
MAIN1:	IN	AL,64h			;GET 8041 STATUS
	TEST	AL,2			;TEST INPUT BUFFER BIT
	JNZ	MAIN1			;IF NOT OK TO WRITE, LOOP
	MOV	AL,13h			;KEYBOARD "LED" COMMAND
	OUT	60h,AL			;SEND COMMAND
MAIN2:	IN	AL,64h			;GET 8041 STATUS
	TEST	AL,2			;TEST INPUT BUFFER BIT
	JNZ	MAIN2			;IF NOT OK TO WRITE, LOOP
	MOV	AL,81h			;CAPSLOCK "LED" ENABLE DATA
	OUT	60h,AL			;SEND DATA
	MOV	AX,4C00h		;EXIT WITHOUT ERROR
	INT	21h			;TO DOS
MAIN		ENDP

CODE_SEG	ENDS

	END	MAIN
